# Copyright (c) 2016, 2018, Oracle and/or its affiliates. All rights reserved.

$ociTopLevelCommands = @(
    'audit', 'bv', 'compute', 'db', 'dns', 'email', 'fs', 'iam', 'lb', 'network', 'os', 'setup'
)

$ociSubcommands = @{
    'audit' = 'config event'
    'audit config' = 'get update'
    'audit event' = 'list'
    'bv' = 'backup boot-volume volume volume-backup-policy volume-backup-policy-assignment volume-group volume-group-backup'
    'bv backup' = 'create delete get list update'
    'bv boot-volume' = 'delete get list update'
    'bv volume' = 'create delete get list update'
    'bv volume-backup-policy' = 'get list'
    'bv volume-backup-policy-assignment' = 'create delete get get-volume-backup-policy-asset-assignment'
    'bv volume-group' = 'create delete get list update'
    'bv volume-group-backup' = 'create delete get list update'
    'compute' = 'boot-volume-attachment console-history image instance instance-console-connection shape vnic-attachment volume-attachment'
    'compute boot-volume-attachment' = 'attach detach get list'
    'compute console-history' = 'capture delete get get-content list update'
    'compute image' = 'create delete export get import list update'
    'compute image export' = 'to-object to-object-uri'
    'compute image import' = 'from-object from-object-uri'
    'compute instance' = 'action attach-vnic detach-vnic get get-windows-initial-creds launch list list-vnics terminate update'
    'compute instance-console-connection' = 'create delete get get-plink-connection-string list'
    'compute shape' = 'list'
    'compute vnic-attachment' = 'get list'
    'compute volume-attachment' = 'attach detach get list'
    'db' = 'backup data-guard-association database node patch patch-history system system-shape version'
    'db backup' = 'create delete get list'
    'db data-guard-association' = 'create failover get list reinstate switchover'
    'db data-guard-association create' = 'from-existing-db-system'
    'db database' = 'create create-from-backup delete get list patch restore update'
    'db node' = 'get list reset soft-reset start stop'
    'db patch' = 'get list'
    'db patch get' = 'by-database by-db-system'
    'db patch list' = 'by-database by-db-system'
    'db patch-history' = 'get list'
    'db patch-history get' = 'by-database by-db-system'
    'db patch-history list' = 'by-database by-db-system'
    'db system' = 'get launch launch-from-backup list patch terminate update'
    'db system-shape' = 'list'
    'db version' = 'list'
    'dns' = 'record zone'
    'dns record' = 'domain rrset zone'
    'dns record domain' = 'delete get patch update'
    'dns record rrset' = 'delete get patch update'
    'dns record zone' = 'get patch update'
    'dns zone' = 'create delete get list update'
    'email' = 'sender suppression'
    'email sender' = 'create delete get list'
    'email suppression' = 'create delete get list'
    'fs' = 'export export-set file-system mount-target snapshot'
    'fs export' = 'create delete get list'
    'fs export-set' = 'get list update'
    'fs file-system' = 'create delete get list update'
    'fs mount-target' = 'create delete get list update'
    'fs snapshot' = 'create delete get list'
    'iam' = 'auth-token availability-domain compartment customer-secret-key dynamic-group group policy region region-subscription smtp-credential tag tag-namespace user'
    'iam auth-token' = 'create delete list update'
    'iam availability-domain' = 'list'
    'iam compartment' = 'create get list update'
    'iam customer-secret-key' = 'create delete list update'
    'iam dynamic-group' = 'create delete get list update'
    'iam group' = 'add-user create delete get list list-users remove-user update'
    'iam policy' = 'create delete get list update'
    'iam region' = 'list'
    'iam region-subscription' = 'create list'
    'iam smtp-credential' = 'create delete list update'
    'iam tag' = 'create get list reactivate retire update'
    'iam tag-namespace' = 'create get list reactivate retire update'
    'iam user' = 'api-key create delete get list list-groups swift-password ui-password update update-user-state'
    'iam user api-key' = 'delete list upload'
    'iam user swift-password' = 'create delete list update'
    'iam user ui-password' = 'create-or-reset'
    'lb' = 'backend backend-health backend-set backend-set-health certificate health-checker hostname listener load-balancer load-balancer-health path-route-set policy protocol shape work-request'
    'lb backend' = 'create delete get list update'
    'lb backend-health' = 'get'
    'lb backend-set' = 'create delete get list update'
    'lb backend-set-health' = 'get'
    'lb certificate' = 'create delete list'
    'lb health-checker' = 'get update'
    'lb hostname' = 'create delete get list update'
    'lb listener' = 'create delete update'
    'lb load-balancer' = 'create delete get list'
    'lb load-balancer-health' = 'get list'
    'lb path-route-set' = 'create delete get list update'
    'lb policy' = 'list'
    'lb protocol' = 'list'
    'lb shape' = 'list'
    'lb work-request' = 'get list'
    'network' = 'cpe cross-connect cross-connect-group cross-connect-location cross-connect-port-speed-shape cross-connect-status dhcp-options drg drg-attachment fast-connect-provider-service internet-gateway ip-sec-connection local-peering-gateway private-ip public-ip remote-peering-connection route-table security-list subnet vcn virtual-circuit virtual-circuit-public-prefix vnic'
    'network cpe' = 'create delete get list update'
    'network cross-connect' = 'create delete get list update'
    'network cross-connect-group' = 'create delete get list update'
    'network cross-connect-location' = 'list'
    'network cross-connect-port-speed-shape' = 'list'
    'network cross-connect-status' = 'get'
    'network dhcp-options' = 'create delete get list update'
    'network drg' = 'create delete get list update'
    'network drg-attachment' = 'create delete get list update'
    'network fast-connect-provider-service' = 'get list virtual-circuit-bandwidth-shape'
    'network fast-connect-provider-service virtual-circuit-bandwidth-shape' = 'list'
    'network internet-gateway' = 'create delete get list update'
    'network ip-sec-connection' = 'create delete get get-config get-status list update'
    'network local-peering-gateway' = 'connect create delete get list update'
    'network private-ip' = 'delete get list update'
    'network public-ip' = 'create delete get list update'
    'network remote-peering-connection' = 'connect create delete get list update'
    'network route-table' = 'create delete get list update'
    'network security-list' = 'create delete get list update'
    'network subnet' = 'create delete get list update'
    'network vcn' = 'create delete get list update'
    'network virtual-circuit' = 'create delete get list update'
    'network virtual-circuit-public-prefix' = 'bulk-add bulk-delete list'
    'network vnic' = 'assign-private-ip get unassign-private-ip update'
    'os' = 'bucket multipart ns object preauth-request'
    'os bucket' = 'create delete get list update'
    'os multipart' = 'abort list'
    'os ns' = 'get get-metadata update-metadata'
    'os object' = 'bulk-delete bulk-download bulk-upload delete get head list put rename restore restore-status resume-put'
    'os preauth-request' = 'create delete get list'
    'setup' = 'autocomplete config keys oci-cli-rc repair-file-permissions'
}
$script:ociSubcommandKeys = $ociSubcommands.Keys -join '|'

$ociCommandsToLongParams = @{
    'audit config get' = 'compartment-id from-json help'
    'audit config update' = 'compartment-id from-json help retention-period-days'
    'audit event list' = 'all compartment-id end-time from-json help page start-time'
    'bv backup create' = 'defined-tags display-name freeform-tags from-json help max-wait-seconds type volume-id wait-for-state wait-interval-seconds'
    'bv backup delete' = 'force from-json help if-match max-wait-seconds volume-backup-id wait-for-state wait-interval-seconds'
    'bv backup get' = 'from-json help volume-backup-id'
    'bv backup list' = 'all compartment-id display-name from-json help lifecycle-state limit page page-size sort-by sort-order volume-id'
    'bv backup update' = 'defined-tags display-name force freeform-tags from-json help if-match max-wait-seconds volume-backup-id wait-for-state wait-interval-seconds'
    'bv boot-volume delete' = 'boot-volume-id force from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
    'bv boot-volume get' = 'boot-volume-id from-json help'
    'bv boot-volume list' = 'all availability-domain compartment-id from-json help limit page page-size volume-group-id'
    'bv boot-volume update' = 'boot-volume-id display-name from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
    'bv volume create' = 'availability-domain backup-policy-id compartment-id defined-tags display-name freeform-tags from-json help max-wait-seconds size-in-gbs size-in-mbs source-volume-id volume-backup-id wait-for-state wait-interval-seconds'
    'bv volume delete' = 'force from-json help if-match max-wait-seconds volume-id wait-for-state wait-interval-seconds'
    'bv volume get' = 'from-json help volume-id'
    'bv volume list' = 'all availability-domain compartment-id display-name from-json help lifecycle-state limit page page-size sort-by sort-order volume-group-id'
    'bv volume update' = 'defined-tags display-name force freeform-tags from-json help if-match max-wait-seconds volume-id wait-for-state wait-interval-seconds'
    'bv volume-backup-policy get' = 'from-json help policy-id'
    'bv volume-backup-policy list' = 'all from-json help limit page page-size'
    'bv volume-backup-policy-assignment create' = 'asset-id from-json help policy-id'
    'bv volume-backup-policy-assignment delete' = 'force from-json help if-match policy-assignment-id'
    'bv volume-backup-policy-assignment get' = 'from-json help policy-assignment-id'
    'bv volume-backup-policy-assignment get-volume-backup-policy-asset-assignment' = 'asset-id from-json help limit page'
    'bv volume-group create' = 'availability-domain compartment-id defined-tags display-name freeform-tags from-json help max-wait-seconds source-details wait-for-state wait-interval-seconds'
    'bv volume-group delete' = 'force from-json help if-match max-wait-seconds volume-group-id wait-for-state wait-interval-seconds'
    'bv volume-group get' = 'from-json help volume-group-id'
    'bv volume-group list' = 'all availability-domain compartment-id display-name from-json help lifecycle-state limit page page-size sort-by sort-order'
    'bv volume-group update' = 'defined-tags display-name force freeform-tags from-json help if-match max-wait-seconds volume-group-id volume-ids wait-for-state wait-interval-seconds'
    'bv volume-group-backup create' = 'compartment-id defined-tags display-name freeform-tags from-json help max-wait-seconds type volume-group-id wait-for-state wait-interval-seconds'
    'bv volume-group-backup delete' = 'force from-json help if-match max-wait-seconds volume-group-backup-id wait-for-state wait-interval-seconds'
    'bv volume-group-backup get' = 'from-json help volume-group-backup-id'
    'bv volume-group-backup list' = 'all compartment-id display-name from-json help limit page page-size sort-by sort-order volume-group-id'
    'bv volume-group-backup update' = 'defined-tags display-name force freeform-tags from-json help if-match max-wait-seconds volume-group-backup-id wait-for-state wait-interval-seconds'
    'compute boot-volume-attachment attach' = 'boot-volume-id display-name from-json help instance-id max-wait-seconds wait-for-state wait-interval-seconds'
    'compute boot-volume-attachment detach' = 'boot-volume-attachment-id force from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
    'compute boot-volume-attachment get' = 'boot-volume-attachment-id from-json help'
    'compute boot-volume-attachment list' = 'all availability-domain boot-volume-id compartment-id from-json help instance-id limit page page-size'
    'compute console-history capture' = 'defined-tags display-name freeform-tags from-json help instance-id max-wait-seconds wait-for-state wait-interval-seconds'
    'compute console-history delete' = 'force from-json help if-match instance-console-history-id max-wait-seconds wait-for-state wait-interval-seconds'
    'compute console-history get' = 'from-json help instance-console-history-id'
    'compute console-history get-content' = 'file from-json help instance-console-history-id length offset'
    'compute console-history list' = 'all availability-domain compartment-id from-json help instance-id lifecycle-state limit page page-size sort-by sort-order'
    'compute console-history update' = 'defined-tags display-name force freeform-tags from-json help if-match instance-console-history-id max-wait-seconds wait-for-state wait-interval-seconds'
    'compute image create' = 'compartment-id defined-tags display-name freeform-tags from-json help image-source-details instance-id launch-mode max-wait-seconds wait-for-state wait-interval-seconds'
    'compute image delete' = 'force from-json help if-match image-id max-wait-seconds wait-for-state wait-interval-seconds'
    'compute image export to-object' = 'bucket-name from-json help if-match image-id name namespace'
    'compute image export to-object-uri' = 'from-json help if-match image-id uri'
    'compute image get' = 'from-json help image-id'
    'compute image import from-object' = 'bucket-name compartment-id defined-tags display-name freeform-tags from-json help launch-mode name namespace source-image-type'
    'compute image import from-object-uri' = 'compartment-id defined-tags display-name freeform-tags from-json help launch-mode source-image-type uri'
    'compute image list' = 'all compartment-id display-name from-json help lifecycle-state limit operating-system operating-system-version page page-size shape sort-by sort-order'
    'compute image update' = 'defined-tags display-name force freeform-tags from-json help if-match image-id max-wait-seconds wait-for-state wait-interval-seconds'
    'compute instance action' = 'action from-json help if-match instance-id max-wait-seconds wait-for-state wait-interval-seconds'
    'compute instance attach-vnic' = 'assign-public-ip defined-tags freeform-tags from-json help hostname-label instance-id nic-index private-ip skip-source-dest-check subnet-id vnic-display-name wait'
    'compute instance detach-vnic' = 'compartment-id force from-json help max-wait-seconds vnic-id wait-for-state wait-interval-seconds'
    'compute instance get' = 'from-json help instance-id'
    'compute instance get-windows-initial-creds' = 'from-json help instance-id'
    'compute instance launch' = 'assign-public-ip availability-domain boot-volume-size-in-gbs compartment-id defined-tags display-name extended-metadata freeform-tags from-json help hostname-label image-id ipxe-script-file max-wait-seconds metadata private-ip shape skip-source-dest-check source-boot-volume-id source-details ssh-authorized-keys-file subnet-id user-data-file vnic-display-name wait-for-state wait-interval-seconds'
    'compute instance list' = 'all availability-domain compartment-id display-name from-json help lifecycle-state limit page page-size sort-by sort-order'
    'compute instance list-vnics' = 'all from-json help instance-id limit page page-size'
    'compute instance terminate' = 'force from-json help if-match instance-id max-wait-seconds preserve-boot-volume wait-for-state wait-interval-seconds'
    'compute instance update' = 'defined-tags display-name force freeform-tags from-json help if-match instance-id max-wait-seconds wait-for-state wait-interval-seconds'
    'compute instance-console-connection create' = 'defined-tags freeform-tags from-json help instance-id max-wait-seconds ssh-public-key-file wait-for-state wait-interval-seconds'
    'compute instance-console-connection delete' = 'force from-json help if-match instance-console-connection-id max-wait-seconds wait-for-state wait-interval-seconds'
    'compute instance-console-connection get' = 'from-json help instance-console-connection-id'
    'compute instance-console-connection get-plink-connection-string' = 'from-json help instance-console-connection-id local-vnc-port private-key-file ssh-proxy-port'
    'compute instance-console-connection list' = 'all compartment-id from-json help instance-id limit page page-size'
    'compute shape list' = 'all availability-domain compartment-id from-json help image-id limit page page-size'
    'compute vnic-attachment get' = 'from-json help vnic-attachment-id'
    'compute vnic-attachment list' = 'all availability-domain compartment-id from-json help instance-id limit page page-size vnic-id'
    'compute volume-attachment attach' = 'display-name from-json help instance-id is-read-only max-wait-seconds type volume-id wait-for-state wait-interval-seconds'
    'compute volume-attachment detach' = 'force from-json help if-match max-wait-seconds volume-attachment-id wait-for-state wait-interval-seconds'
    'compute volume-attachment get' = 'from-json help volume-attachment-id'
    'compute volume-attachment list' = 'all availability-domain compartment-id from-json help instance-id limit page page-size volume-id'
    'db backup create' = 'database-id display-name from-json help max-wait-seconds wait-for-state wait-interval-seconds'
    'db backup delete' = 'backup-id force from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
    'db backup get' = 'backup-id from-json help'
    'db backup list' = 'all compartment-id database-id from-json help limit page page-size'
    'db data-guard-association create from-existing-db-system' = 'creation-type database-admin-password database-id from-json help peer-db-system-id protection-mode transport-type'
    'db data-guard-association failover' = 'data-guard-association-id database-admin-password database-id from-json help if-match'
    'db data-guard-association get' = 'data-guard-association-id database-id from-json help'
    'db data-guard-association list' = 'all database-id from-json help limit page page-size'
    'db data-guard-association reinstate' = 'data-guard-association-id database-admin-password database-id from-json help if-match'
    'db data-guard-association switchover' = 'data-guard-association-id database-admin-password database-id from-json help if-match'
    'db database create' = 'admin-password character-set db-name db-system-id db-version db-workload from-json help max-wait-seconds ncharacter-set pdb-name source wait-for-state wait-interval-seconds'
    'db database create-from-backup' = 'admin-password backup-id backup-tde-password db-system-id from-json help max-wait-seconds wait-for-state wait-interval-seconds'
    'db database delete' = 'database-id force from-json help'
    'db database get' = 'database-id from-json help'
    'db database list' = 'compartment-id db-system-id from-json help limit'
    'db database patch' = 'database-id from-json help patch-action patch-id'
    'db database restore' = 'database-id database-scn from-json help if-match latest timestamp'
    'db database update' = 'auto-backup-enabled database-id defined-tags force freeform-tags from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
    'db node get' = 'db-node-id from-json help'
    'db node list' = 'all compartment-id db-system-id from-json help limit page page-size'
    'db node reset' = 'db-node-id from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
    'db node soft-reset' = 'db-node-id from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
    'db node start' = 'db-node-id from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
    'db node stop' = 'db-node-id from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
    'db patch get by-database' = 'database-id from-json help patch-id'
    'db patch get by-db-system' = 'db-system-id from-json help patch-id'
    'db patch list by-database' = 'all database-id from-json help limit page page-size'
    'db patch list by-db-system' = 'all db-system-id from-json help limit page page-size'
    'db patch-history get by-database' = 'database-id from-json help patch-history-entry-id'
    'db patch-history get by-db-system' = 'db-system-id from-json help patch-history-entry-id'
    'db patch-history list by-database' = 'all database-id from-json help limit page page-size'
    'db patch-history list by-db-system' = 'all db-system-id from-json help limit page page-size'
    'db system get' = 'db-system-id from-json help'
    'db system launch' = 'admin-password availability-domain backup-subnet-id character-set cluster-name compartment-id cpu-core-count data-storage-percentage database-edition db-name db-version db-workload defined-tags disk-redundancy display-name domain freeform-tags from-json help hostname initial-data-storage-size-in-gb license-model max-wait-seconds ncharacter-set node-count pdb-name shape ssh-authorized-keys-file subnet-id wait-for-state wait-interval-seconds'
    'db system launch-from-backup' = 'admin-password availability-domain backup-id backup-subnet-id backup-tde-password cluster-name compartment-id cpu-core-count data-storage-percentage database-edition defined-tags disk-redundancy display-name domain freeform-tags from-json help hostname initial-data-storage-size-in-gb license-model max-wait-seconds node-count shape ssh-authorized-keys-file subnet-id wait-for-state wait-interval-seconds'
    'db system list' = 'all backup-id compartment-id from-json help limit page page-size'
    'db system patch' = 'db-system-id from-json help patch-action patch-id'
    'db system terminate' = 'db-system-id force from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
    'db system update' = 'cpu-core-count data-storage-size-in-gbs db-system-id defined-tags force freeform-tags from-json help if-match max-wait-seconds patch-action patch-id ssh-authorized-keys-file wait-for-state wait-interval-seconds'
    'db system-shape list' = 'all availability-domain compartment-id from-json help limit page page-size'
    'db version list' = 'all compartment-id db-system-id db-system-shape from-json help limit page page-size'
    'dns record domain delete' = 'compartment-id domain force from-json help if-match if-unmodified-since zone-name-or-id'
    'dns record domain get' = 'all compartment-id domain from-json help if-modified-since if-none-match limit page page-size rtype sort-by sort-order zone-name-or-id zone-version'
    'dns record domain patch' = 'compartment-id domain from-json help if-match if-unmodified-since items zone-name-or-id'
    'dns record domain update' = 'compartment-id domain force from-json help if-match if-unmodified-since items zone-name-or-id'
    'dns record rrset delete' = 'compartment-id domain force from-json help if-match if-unmodified-since rtype zone-name-or-id'
    'dns record rrset get' = 'all compartment-id domain from-json help if-modified-since if-none-match limit page page-size rtype zone-name-or-id zone-version'
    'dns record rrset patch' = 'compartment-id domain from-json help if-match if-unmodified-since items rtype zone-name-or-id'
    'dns record rrset update' = 'compartment-id domain force from-json help if-match if-unmodified-since items rtype zone-name-or-id'
    'dns record zone get' = 'all compartment-id domain domain-contains from-json help if-modified-since if-none-match limit page page-size rtype sort-by sort-order zone-name-or-id zone-version'
    'dns record zone patch' = 'compartment-id from-json help if-match if-unmodified-since items zone-name-or-id'
    'dns record zone update' = 'compartment-id force from-json help if-match if-unmodified-since items zone-name-or-id'
    'dns zone create' = 'compartment-id external-masters from-json help max-wait-seconds name wait-for-state wait-interval-seconds zone-type'
    'dns zone delete' = 'compartment-id force from-json help if-match if-unmodified-since max-wait-seconds wait-for-state wait-interval-seconds zone-name-or-id'
    'dns zone get' = 'compartment-id from-json help if-modified-since if-none-match zone-name-or-id'
    'dns zone list' = 'all compartment-id from-json help lifecycle-state limit name name-contains page page-size sort-by sort-order time-created-greater-than-or-equal-to time-created-less-than zone-type'
    'dns zone update' = 'compartment-id external-masters force from-json help if-match if-unmodified-since max-wait-seconds wait-for-state wait-interval-seconds zone-name-or-id'
    'email sender create' = 'compartment-id email-address from-json help max-wait-seconds wait-for-state wait-interval-seconds'
    'email sender delete' = 'force from-json help max-wait-seconds sender-id wait-for-state wait-interval-seconds'
    'email sender get' = 'from-json help sender-id'
    'email sender list' = 'all compartment-id email-address from-json help lifecycle-state limit page page-size sort-by sort-order'
    'email suppression create' = 'compartment-id email-address from-json help'
    'email suppression delete' = 'force from-json help suppression-id'
    'email suppression get' = 'from-json help suppression-id'
    'email suppression list' = 'all compartment-id email-address from-json help limit page page-size sort-by sort-order time-created-greater-than-or-equal-to time-created-less-than'
    'fs export create' = 'export-set-id file-system-id from-json help max-wait-seconds path wait-for-state wait-interval-seconds'
    'fs export delete' = 'export-id force from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
    'fs export get' = 'export-id from-json help'
    'fs export list' = 'all compartment-id export-set-id file-system-id from-json help id lifecycle-state limit page page-size sort-by sort-order'
    'fs export-set get' = 'export-set-id from-json help'
    'fs export-set list' = 'all availability-domain compartment-id display-name from-json help id lifecycle-state limit page page-size sort-by sort-order'
    'fs export-set update' = 'display-name export-set-id from-json help if-match max-fs-stat-bytes max-fs-stat-files max-wait-seconds wait-for-state wait-interval-seconds'
    'fs file-system create' = 'availability-domain compartment-id display-name from-json help max-wait-seconds wait-for-state wait-interval-seconds'
    'fs file-system delete' = 'file-system-id force from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
    'fs file-system get' = 'file-system-id from-json help'
    'fs file-system list' = 'all availability-domain compartment-id display-name from-json help id lifecycle-state limit page page-size sort-by sort-order'
    'fs file-system update' = 'display-name file-system-id from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
    'fs mount-target create' = 'availability-domain compartment-id display-name from-json help hostname-label ip-address max-wait-seconds subnet-id wait-for-state wait-interval-seconds'
    'fs mount-target delete' = 'force from-json help if-match max-wait-seconds mount-target-id wait-for-state wait-interval-seconds'
    'fs mount-target get' = 'from-json help mount-target-id'
    'fs mount-target list' = 'all availability-domain compartment-id display-name export-set-id from-json help id lifecycle-state limit page page-size sort-by sort-order'
    'fs mount-target update' = 'display-name from-json help if-match max-wait-seconds mount-target-id wait-for-state wait-interval-seconds'
    'fs snapshot create' = 'file-system-id from-json help max-wait-seconds name wait-for-state wait-interval-seconds'
    'fs snapshot delete' = 'force from-json help if-match max-wait-seconds snapshot-id wait-for-state wait-interval-seconds'
    'fs snapshot get' = 'from-json help snapshot-id'
    'fs snapshot list' = 'all file-system-id from-json help id lifecycle-state limit page page-size sort-order'
    'iam auth-token create' = 'description from-json help user-id'
    'iam auth-token delete' = 'auth-token-id force from-json help if-match user-id'
    'iam auth-token list' = 'from-json help user-id'
    'iam auth-token update' = 'auth-token-id description from-json help if-match user-id'
    'iam availability-domain list' = 'compartment-id from-json help'
    'iam compartment create' = 'compartment-id defined-tags description freeform-tags from-json help max-wait-seconds name wait-for-state wait-interval-seconds'
    'iam compartment get' = 'compartment-id from-json help'
    'iam compartment list' = 'all compartment-id from-json help limit page page-size'
    'iam compartment update' = 'compartment-id defined-tags description force freeform-tags from-json help if-match max-wait-seconds name wait-for-state wait-interval-seconds'
    'iam customer-secret-key create' = 'display-name from-json help user-id'
    'iam customer-secret-key delete' = 'customer-secret-key-id force from-json help if-match user-id'
    'iam customer-secret-key list' = 'from-json help user-id'
    'iam customer-secret-key update' = 'customer-secret-key-id display-name from-json help if-match user-id'
    'iam dynamic-group create' = 'compartment-id description from-json help matching-rule max-wait-seconds name wait-for-state wait-interval-seconds'
    'iam dynamic-group delete' = 'dynamic-group-id force from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
    'iam dynamic-group get' = 'dynamic-group-id from-json help'
    'iam dynamic-group list' = 'all compartment-id from-json help limit page page-size'
    'iam dynamic-group update' = 'description dynamic-group-id from-json help if-match matching-rule max-wait-seconds wait-for-state wait-interval-seconds'
    'iam group add-user' = 'from-json group-id help user-id'
    'iam group create' = 'compartment-id defined-tags description freeform-tags from-json help max-wait-seconds name wait-for-state wait-interval-seconds'
    'iam group delete' = 'force from-json group-id help if-match max-wait-seconds wait-for-state wait-interval-seconds'
    'iam group get' = 'from-json group-id help'
    'iam group list' = 'all compartment-id from-json help limit page page-size'
    'iam group list-users' = 'all compartment-id from-json group-id help limit page page-size'
    'iam group remove-user' = 'compartment-id force from-json group-id help user-id'
    'iam group update' = 'defined-tags description force freeform-tags from-json group-id help if-match max-wait-seconds wait-for-state wait-interval-seconds'
    'iam policy create' = 'compartment-id defined-tags description freeform-tags from-json help max-wait-seconds name statements version-date wait-for-state wait-interval-seconds'
    'iam policy delete' = 'force from-json help if-match max-wait-seconds policy-id wait-for-state wait-interval-seconds'
    'iam policy get' = 'from-json help policy-id'
    'iam policy list' = 'all compartment-id from-json help limit page page-size'
    'iam policy update' = 'defined-tags description force freeform-tags from-json help if-match policy-id statements version-date'
    'iam region list' = 'from-json help'
    'iam region-subscription create' = 'from-json help region-key tenancy-id'
    'iam region-subscription list' = 'from-json help tenancy-id'
    'iam smtp-credential create' = 'description from-json help user-id'
    'iam smtp-credential delete' = 'force from-json help if-match smtp-credential-id user-id'
    'iam smtp-credential list' = 'from-json help user-id'
    'iam smtp-credential update' = 'description from-json help if-match smtp-credential-id user-id'
    'iam tag create' = 'defined-tags description freeform-tags from-json help name tag-namespace-id'
    'iam tag get' = 'from-json help tag-name tag-namespace-id'
    'iam tag list' = 'all from-json help limit page page-size tag-namespace-id'
    'iam tag reactivate' = 'from-json help tag-name tag-namespace-id'
    'iam tag retire' = 'from-json help tag-name tag-namespace-id'
    'iam tag update' = 'defined-tags description force freeform-tags from-json help tag-name tag-namespace-id'
    'iam tag-namespace create' = 'compartment-id defined-tags description freeform-tags from-json help name'
    'iam tag-namespace get' = 'from-json help tag-namespace-id'
    'iam tag-namespace list' = 'all compartment-id from-json help include-subcompartments limit page page-size'
    'iam tag-namespace reactivate' = 'from-json help tag-namespace-id'
    'iam tag-namespace retire' = 'from-json help tag-namespace-id'
    'iam tag-namespace update' = 'defined-tags description force freeform-tags from-json help tag-namespace-id'
    'iam user api-key delete' = 'fingerprint force from-json help if-match user-id'
    'iam user api-key list' = 'from-json help user-id'
    'iam user api-key upload' = 'from-json help key key-file user-id'
    'iam user create' = 'compartment-id defined-tags description freeform-tags from-json help max-wait-seconds name wait-for-state wait-interval-seconds'
    'iam user delete' = 'force from-json help if-match max-wait-seconds user-id wait-for-state wait-interval-seconds'
    'iam user get' = 'from-json help user-id'
    'iam user list' = 'all compartment-id from-json help limit page page-size'
    'iam user list-groups' = 'all compartment-id from-json help limit page page-size user-id'
    'iam user swift-password create' = 'description from-json help user-id'
    'iam user swift-password delete' = 'force from-json help if-match swift-password-id user-id'
    'iam user swift-password list' = 'from-json help user-id'
    'iam user swift-password update' = 'description from-json help if-match swift-password-id user-id'
    'iam user ui-password create-or-reset' = 'from-json help user-id'
    'iam user update' = 'defined-tags description force freeform-tags from-json help if-match max-wait-seconds user-id wait-for-state wait-interval-seconds'
    'iam user update-user-state' = 'blocked from-json help if-match user-id'
    'lb backend create' = 'backend-set-name backup drain from-json help ip-address load-balancer-id max-wait-seconds offline port wait-for-state wait-interval-seconds weight'
    'lb backend delete' = 'backend-name backend-set-name force from-json help load-balancer-id max-wait-seconds wait-for-state wait-interval-seconds'
    'lb backend get' = 'backend-name backend-set-name from-json help load-balancer-id'
    'lb backend list' = 'backend-set-name from-json help load-balancer-id'
    'lb backend update' = 'backend-name backend-set-name backup drain from-json help load-balancer-id max-wait-seconds offline wait-for-state wait-interval-seconds weight'
    'lb backend-health get' = 'backend-name backend-set-name from-json help load-balancer-id'
    'lb backend-set create' = 'backends from-json health-checker-interval-in-ms health-checker-port health-checker-protocol health-checker-response-body-regex health-checker-retries health-checker-return-code health-checker-timeout-in-ms health-checker-url-path help load-balancer-id max-wait-seconds name policy session-persistence-cookie-name session-persistence-disable-fallback ssl-certificate-name ssl-verify-depth ssl-verify-peer-certificate wait-for-state wait-interval-seconds'
    'lb backend-set delete' = 'backend-set-name force from-json help load-balancer-id max-wait-seconds wait-for-state wait-interval-seconds'
    'lb backend-set get' = 'backend-set-name from-json help load-balancer-id'
    'lb backend-set list' = 'from-json help load-balancer-id'
    'lb backend-set update' = 'backend-set-name backends force from-json health-checker-interval-in-ms health-checker-port health-checker-protocol health-checker-response-body-regex health-checker-retries health-checker-return-code health-checker-timeout-in-ms health-checker-url-path help load-balancer-id max-wait-seconds policy session-persistence-cookie-name session-persistence-disable-fallback ssl-certificate-name ssl-verify-depth ssl-verify-peer-certificate wait-for-state wait-interval-seconds'
    'lb backend-set-health get' = 'backend-set-name from-json help load-balancer-id'
    'lb certificate create' = 'ca-certificate-file certificate-name from-json help load-balancer-id max-wait-seconds passphrase private-key-file public-certificate-file wait-for-state wait-interval-seconds'
    'lb certificate delete' = 'certificate-name force from-json help load-balancer-id max-wait-seconds wait-for-state wait-interval-seconds'
    'lb certificate list' = 'from-json help load-balancer-id'
    'lb health-checker get' = 'backend-set-name from-json help load-balancer-id'
    'lb health-checker update' = 'backend-set-name from-json help interval-in-millis load-balancer-id max-wait-seconds port protocol response-body-regex retries return-code timeout-in-millis url-path wait-for-state wait-interval-seconds'
    'lb hostname create' = 'from-json help hostname load-balancer-id max-wait-seconds name wait-for-state wait-interval-seconds'
    'lb hostname delete' = 'force from-json help load-balancer-id max-wait-seconds name wait-for-state wait-interval-seconds'
    'lb hostname get' = 'from-json help load-balancer-id name'
    'lb hostname list' = 'from-json help load-balancer-id'
    'lb hostname update' = 'from-json help hostname load-balancer-id max-wait-seconds name wait-for-state wait-interval-seconds'
    'lb listener create' = 'connection-configuration-idle-timeout default-backend-set-name from-json help hostname-names load-balancer-id max-wait-seconds name path-route-set-name port protocol ssl-certificate-name ssl-verify-depth ssl-verify-peer-certificate wait-for-state wait-interval-seconds'
    'lb listener delete' = 'force from-json help listener-name load-balancer-id max-wait-seconds wait-for-state wait-interval-seconds'
    'lb listener update' = 'connection-configuration-idle-timeout default-backend-set-name force from-json help hostname-names listener-name load-balancer-id max-wait-seconds path-route-set-name port protocol ssl-certificate-name ssl-verify-depth ssl-verify-peer-certificate wait-for-state wait-interval-seconds'
    'lb load-balancer create' = 'backend-sets certificates compartment-id display-name from-json help hostnames is-private listeners max-wait-seconds path-route-sets shape-name subnet-ids wait-for-state wait-interval-seconds'
    'lb load-balancer delete' = 'force from-json help load-balancer-id max-wait-seconds wait-for-state wait-interval-seconds'
    'lb load-balancer get' = 'from-json help load-balancer-id'
    'lb load-balancer list' = 'all compartment-id detail display-name from-json help lifecycle-state limit page page-size sort-by sort-order'
    'lb load-balancer-health get' = 'from-json help load-balancer-id'
    'lb load-balancer-health list' = 'all compartment-id from-json help limit page page-size'
    'lb path-route-set create' = 'from-json help load-balancer-id max-wait-seconds name path-routes wait-for-state wait-interval-seconds'
    'lb path-route-set delete' = 'force from-json help load-balancer-id max-wait-seconds path-route-set-name wait-for-state wait-interval-seconds'
    'lb path-route-set get' = 'from-json help load-balancer-id path-route-set-name'
    'lb path-route-set list' = 'from-json help load-balancer-id'
    'lb path-route-set update' = 'force from-json help load-balancer-id max-wait-seconds path-route-set-name path-routes wait-for-state wait-interval-seconds'
    'lb policy list' = 'all compartment-id from-json help limit page page-size'
    'lb protocol list' = 'all compartment-id from-json help limit page page-size'
    'lb shape list' = 'all compartment-id from-json help limit page page-size'
    'lb work-request get' = 'from-json help work-request-id'
    'lb work-request list' = 'all from-json help limit load-balancer-id page page-size'
    'network cpe create' = 'compartment-id defined-tags display-name freeform-tags from-json help ip-address'
    'network cpe delete' = 'cpe-id force from-json help if-match'
    'network cpe get' = 'cpe-id from-json help'
    'network cpe list' = 'all compartment-id from-json help limit page page-size'
    'network cpe update' = 'cpe-id defined-tags display-name force freeform-tags from-json help if-match'
    'network cross-connect create' = 'compartment-id cross-connect-group-id display-name far-cross-connect-or-cross-connect-group-id from-json help location-name max-wait-seconds near-cross-connect-or-cross-connect-group-id port-speed-shape-name wait-for-state wait-interval-seconds'
    'network cross-connect delete' = 'cross-connect-id force from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
    'network cross-connect get' = 'cross-connect-id from-json help'
    'network cross-connect list' = 'all compartment-id cross-connect-group-id display-name from-json help lifecycle-state limit page page-size sort-by sort-order'
    'network cross-connect update' = 'cross-connect-id display-name from-json help if-match is-active max-wait-seconds wait-for-state wait-interval-seconds'
    'network cross-connect-group create' = 'compartment-id display-name from-json help max-wait-seconds wait-for-state wait-interval-seconds'
    'network cross-connect-group delete' = 'cross-connect-group-id force from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
    'network cross-connect-group get' = 'cross-connect-group-id from-json help'
    'network cross-connect-group list' = 'all compartment-id display-name from-json help lifecycle-state limit page page-size sort-by sort-order'
    'network cross-connect-group update' = 'cross-connect-group-id display-name from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
    'network cross-connect-location list' = 'all compartment-id from-json help limit page page-size'
    'network cross-connect-port-speed-shape list' = 'all compartment-id from-json help limit page page-size'
    'network cross-connect-status get' = 'cross-connect-id from-json help'
    'network dhcp-options create' = 'compartment-id defined-tags display-name freeform-tags from-json help max-wait-seconds options vcn-id wait-for-state wait-interval-seconds'
    'network dhcp-options delete' = 'dhcp-id force from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
    'network dhcp-options get' = 'dhcp-id from-json help'
    'network dhcp-options list' = 'all compartment-id display-name from-json help lifecycle-state limit page page-size sort-by sort-order vcn-id'
    'network dhcp-options update' = 'defined-tags dhcp-id display-name force freeform-tags from-json help if-match max-wait-seconds options wait-for-state wait-interval-seconds'
    'network drg create' = 'compartment-id defined-tags display-name freeform-tags from-json help max-wait-seconds wait-for-state wait-interval-seconds'
    'network drg delete' = 'drg-id force from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
    'network drg get' = 'drg-id from-json help'
    'network drg list' = 'all compartment-id from-json help limit page page-size'
    'network drg update' = 'defined-tags display-name drg-id force freeform-tags from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
    'network drg-attachment create' = 'display-name drg-id from-json help max-wait-seconds vcn-id wait-for-state wait-interval-seconds'
    'network drg-attachment delete' = 'drg-attachment-id force from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
    'network drg-attachment get' = 'drg-attachment-id from-json help'
    'network drg-attachment list' = 'all compartment-id drg-id from-json help limit page page-size vcn-id'
    'network drg-attachment update' = 'display-name drg-attachment-id from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
    'network fast-connect-provider-service get' = 'from-json help provider-service-id'
    'network fast-connect-provider-service list' = 'all compartment-id from-json help limit page page-size'
    'network fast-connect-provider-service virtual-circuit-bandwidth-shape list' = 'all from-json help limit page page-size provider-service-id'
    'network internet-gateway create' = 'compartment-id defined-tags display-name freeform-tags from-json help is-enabled max-wait-seconds vcn-id wait-for-state wait-interval-seconds'
    'network internet-gateway delete' = 'force from-json help if-match ig-id max-wait-seconds wait-for-state wait-interval-seconds'
    'network internet-gateway get' = 'from-json help ig-id'
    'network internet-gateway list' = 'all compartment-id display-name from-json help lifecycle-state limit page page-size sort-by sort-order vcn-id'
    'network internet-gateway update' = 'defined-tags display-name force freeform-tags from-json help if-match ig-id is-enabled max-wait-seconds wait-for-state wait-interval-seconds'
    'network ip-sec-connection create' = 'compartment-id cpe-id defined-tags display-name drg-id freeform-tags from-json help max-wait-seconds static-routes wait-for-state wait-interval-seconds'
    'network ip-sec-connection delete' = 'force from-json help if-match ipsc-id max-wait-seconds wait-for-state wait-interval-seconds'
    'network ip-sec-connection get' = 'from-json help ipsc-id'
    'network ip-sec-connection get-config' = 'from-json help ipsc-id'
    'network ip-sec-connection get-status' = 'from-json help ipsc-id'
    'network ip-sec-connection list' = 'all compartment-id cpe-id drg-id from-json help limit page page-size'
    'network ip-sec-connection update' = 'defined-tags display-name force freeform-tags from-json help if-match ipsc-id max-wait-seconds wait-for-state wait-interval-seconds'
    'network local-peering-gateway connect' = 'from-json help local-peering-gateway-id peer-id'
    'network local-peering-gateway create' = 'compartment-id defined-tags display-name freeform-tags from-json help max-wait-seconds vcn-id wait-for-state wait-interval-seconds'
    'network local-peering-gateway delete' = 'force from-json help if-match local-peering-gateway-id max-wait-seconds wait-for-state wait-interval-seconds'
    'network local-peering-gateway get' = 'from-json help local-peering-gateway-id'
    'network local-peering-gateway list' = 'all compartment-id from-json help limit page page-size vcn-id'
    'network local-peering-gateway update' = 'defined-tags display-name force freeform-tags from-json help if-match local-peering-gateway-id max-wait-seconds wait-for-state wait-interval-seconds'
    'network private-ip delete' = 'force from-json help if-match private-ip-id'
    'network private-ip get' = 'from-json help private-ip-id'
    'network private-ip list' = 'all from-json help ip-address limit page page-size subnet-id vnic-id'
    'network private-ip update' = 'defined-tags display-name force freeform-tags from-json help hostname-label if-match private-ip-id'
    'network public-ip create' = 'compartment-id defined-tags display-name freeform-tags from-json help lifetime max-wait-seconds private-ip-id wait-for-state wait-interval-seconds'
    'network public-ip delete' = 'force from-json help if-match max-wait-seconds public-ip-id wait-for-state wait-interval-seconds'
    'network public-ip get' = 'from-json help private-ip-id public-ip-address public-ip-id'
    'network public-ip list' = 'all availability-domain compartment-id from-json help limit page page-size scope'
    'network public-ip update' = 'defined-tags display-name force freeform-tags from-json help if-match max-wait-seconds private-ip-id public-ip-id wait-for-state wait-interval-seconds'
    'network remote-peering-connection connect' = 'from-json help peer-id peer-region-name remote-peering-connection-id'
    'network remote-peering-connection create' = 'compartment-id display-name drg-id from-json help max-wait-seconds wait-for-state wait-interval-seconds'
    'network remote-peering-connection delete' = 'force from-json help if-match max-wait-seconds remote-peering-connection-id wait-for-state wait-interval-seconds'
    'network remote-peering-connection get' = 'from-json help remote-peering-connection-id'
    'network remote-peering-connection list' = 'all compartment-id drg-id from-json help limit page page-size'
    'network remote-peering-connection update' = 'display-name from-json help if-match max-wait-seconds remote-peering-connection-id wait-for-state wait-interval-seconds'
    'network route-table create' = 'compartment-id defined-tags display-name freeform-tags from-json help max-wait-seconds route-rules vcn-id wait-for-state wait-interval-seconds'
    'network route-table delete' = 'force from-json help if-match max-wait-seconds rt-id wait-for-state wait-interval-seconds'
    'network route-table get' = 'from-json help rt-id'
    'network route-table list' = 'all compartment-id display-name from-json help lifecycle-state limit page page-size sort-by sort-order vcn-id'
    'network route-table update' = 'defined-tags display-name force freeform-tags from-json help if-match max-wait-seconds route-rules rt-id wait-for-state wait-interval-seconds'
    'network security-list create' = 'compartment-id defined-tags display-name egress-security-rules freeform-tags from-json help ingress-security-rules max-wait-seconds vcn-id wait-for-state wait-interval-seconds'
    'network security-list delete' = 'force from-json help if-match max-wait-seconds security-list-id wait-for-state wait-interval-seconds'
    'network security-list get' = 'from-json help security-list-id'
    'network security-list list' = 'all compartment-id display-name from-json help lifecycle-state limit page page-size sort-by sort-order vcn-id'
    'network security-list update' = 'defined-tags display-name egress-security-rules force freeform-tags from-json help if-match ingress-security-rules max-wait-seconds security-list-id wait-for-state wait-interval-seconds'
    'network subnet create' = 'availability-domain cidr-block compartment-id defined-tags dhcp-options-id display-name dns-label freeform-tags from-json help max-wait-seconds prohibit-public-ip-on-vnic route-table-id security-list-ids vcn-id wait-for-state wait-interval-seconds'
    'network subnet delete' = 'force from-json help if-match max-wait-seconds subnet-id wait-for-state wait-interval-seconds'
    'network subnet get' = 'from-json help subnet-id'
    'network subnet list' = 'all compartment-id display-name from-json help lifecycle-state limit page page-size sort-by sort-order vcn-id'
    'network subnet update' = 'defined-tags display-name force freeform-tags from-json help if-match max-wait-seconds subnet-id wait-for-state wait-interval-seconds'
    'network vcn create' = 'cidr-block compartment-id defined-tags display-name dns-label freeform-tags from-json help max-wait-seconds wait-for-state wait-interval-seconds'
    'network vcn delete' = 'force from-json help if-match max-wait-seconds vcn-id wait-for-state wait-interval-seconds'
    'network vcn get' = 'from-json help vcn-id'
    'network vcn list' = 'all compartment-id display-name from-json help lifecycle-state limit page page-size sort-by sort-order'
    'network vcn update' = 'defined-tags display-name force freeform-tags from-json help if-match max-wait-seconds vcn-id wait-for-state wait-interval-seconds'
    'network virtual-circuit create' = 'bandwidth-shape-name compartment-id cross-connect-mappings customer-bgp-asn display-name from-json gateway-id help max-wait-seconds provider-name provider-service-id provider-service-name public-prefixes region type wait-for-state wait-interval-seconds'
    'network virtual-circuit delete' = 'force from-json help if-match max-wait-seconds virtual-circuit-id wait-for-state wait-interval-seconds'
    'network virtual-circuit get' = 'from-json help virtual-circuit-id'
    'network virtual-circuit list' = 'all compartment-id display-name from-json help lifecycle-state limit page page-size sort-by sort-order'
    'network virtual-circuit update' = 'bandwidth-shape-name cross-connect-mappings customer-bgp-asn display-name force from-json gateway-id help if-match max-wait-seconds provider-state reference-comment virtual-circuit-id wait-for-state wait-interval-seconds'
    'network virtual-circuit-public-prefix bulk-add' = 'from-json help public-prefixes virtual-circuit-id'
    'network virtual-circuit-public-prefix bulk-delete' = 'from-json help public-prefixes virtual-circuit-id'
    'network virtual-circuit-public-prefix list' = 'from-json help verification-state virtual-circuit-id'
    'network vnic assign-private-ip' = 'defined-tags display-name freeform-tags from-json help hostname-label ip-address unassign-if-already-assigned vnic-id'
    'network vnic get' = 'from-json help vnic-id'
    'network vnic unassign-private-ip' = 'from-json help ip-address vnic-id'
    'network vnic update' = 'defined-tags display-name force freeform-tags from-json help hostname-label if-match max-wait-seconds skip-source-dest-check vnic-id wait-for-state wait-interval-seconds'
    'os bucket create' = 'compartment-id defined-tags freeform-tags from-json help metadata name namespace namespace-name public-access-type storage-tier'
    'os bucket delete' = 'bucket-name force from-json help if-match name namespace namespace-name'
    'os bucket get' = 'bucket-name from-json help if-match if-none-match name namespace namespace-name'
    'os bucket list' = 'all compartment-id fields from-json help limit namespace namespace-name page page-size'
    'os bucket update' = 'bucket-name compartment-id defined-tags freeform-tags from-json help if-match metadata name namespace namespace-name public-access-type'
    'os multipart abort' = 'bucket-name force from-json help namespace object-name upload-id'
    'os multipart list' = 'all bucket-name from-json help limit namespace namespace-name page page-size'
    'os ns get' = 'from-json help'
    'os ns get-metadata' = 'from-json help namespace namespace-name'
    'os ns update-metadata' = 'default-s3-compartment-id default-swift-compartment-id from-json help namespace namespace-name'
    'os object bulk-delete' = 'bucket-name delimiter dry-run exclude force from-json help include namespace parallel-operations-count prefix'
    'os object bulk-download' = 'bucket-name delimiter download-dir exclude from-json help include multipart-download-threshold namespace no-overwrite overwrite parallel-operations-count part-size prefix'
    'os object bulk-upload' = 'bucket-name content-encoding content-language content-type disable-parallel-uploads exclude from-json help include metadata namespace no-multipart no-overwrite object-prefix overwrite parallel-upload-count part-size src-dir'
    'os object delete' = 'bucket-name force from-json help if-match name namespace namespace-name object-name'
    'os object get' = 'bucket-name file from-json help if-match if-none-match multipart-download-threshold name namespace parallel-download-count part-size range'
    'os object head' = 'bucket-name from-json help if-match if-none-match name namespace'
    'os object list' = 'all bucket-name delimiter end fields from-json help limit namespace page-size prefix start'
    'os object put' = 'bucket-name content-encoding content-language content-md5 content-type disable-parallel-uploads file force from-json help if-match metadata name namespace no-multipart no-overwrite parallel-upload-count part-size'
    'os object rename' = 'bucket bucket-name from-json help name namespace namespace-name new-if-match new-if-none-match new-name new-obj-if-match-e-tag new-obj-if-none-match-e-tag source-name src-if-match src-obj-if-match-e-tag'
    'os object restore' = 'bucket from-json help hours name namespace'
    'os object restore-status' = 'bucket-name from-json help name namespace'
    'os object resume-put' = 'bucket-name disable-parallel-uploads file from-json help name namespace parallel-upload-count part-size upload-id'
    'os preauth-request create' = 'access-type bucket-name from-json help name namespace namespace-name object-name time-expires'
    'os preauth-request delete' = 'bucket-name force from-json help namespace namespace-name par-id'
    'os preauth-request get' = 'bucket-name from-json help namespace namespace-name par-id'
    'os preauth-request list' = 'all bucket-name from-json help limit namespace namespace-name object-name-prefix page page-size'
    'setup autocomplete' = 'help'
    'setup config' = 'help'
    'setup keys' = 'help key-name output-dir overwrite passphrase passphrase-file'
    'setup oci-cli-rc' = 'file help'
    'setup repair-file-permissions' = 'file help'
}
$script:ociCommandsWithLongParams = $ociCommandsToLongParams.Keys -join '|'

$ociCommandsToShortParams = @{
    'audit config get' = '? c h'
    'audit config update' = '? c h'
    'audit event list' = '? c h'
    'bv backup create' = '? h'
    'bv backup delete' = '? h'
    'bv backup get' = '? h'
    'bv backup list' = '? c h'
    'bv backup update' = '? h'
    'bv boot-volume delete' = '? h'
    'bv boot-volume get' = '? h'
    'bv boot-volume list' = '? c h'
    'bv boot-volume update' = '? h'
    'bv volume create' = '? c h'
    'bv volume delete' = '? h'
    'bv volume get' = '? h'
    'bv volume list' = '? c h'
    'bv volume update' = '? h'
    'bv volume-backup-policy get' = '? h'
    'bv volume-backup-policy list' = '? h'
    'bv volume-backup-policy-assignment create' = '? h'
    'bv volume-backup-policy-assignment delete' = '? h'
    'bv volume-backup-policy-assignment get' = '? h'
    'bv volume-backup-policy-assignment get-volume-backup-policy-asset-assignment' = '? h'
    'bv volume-group create' = '? c h'
    'bv volume-group delete' = '? h'
    'bv volume-group get' = '? h'
    'bv volume-group list' = '? c h'
    'bv volume-group update' = '? h'
    'bv volume-group-backup create' = '? c h'
    'bv volume-group-backup delete' = '? h'
    'bv volume-group-backup get' = '? h'
    'bv volume-group-backup list' = '? c h'
    'bv volume-group-backup update' = '? h'
    'compute boot-volume-attachment attach' = '? h'
    'compute boot-volume-attachment detach' = '? h'
    'compute boot-volume-attachment get' = '? h'
    'compute boot-volume-attachment list' = '? c h'
    'compute console-history capture' = '? h'
    'compute console-history delete' = '? h'
    'compute console-history get' = '? h'
    'compute console-history get-content' = '? h'
    'compute console-history list' = '? c h'
    'compute console-history update' = '? h'
    'compute image create' = '? c h'
    'compute image delete' = '? h'
    'compute image export to-object' = '? bn h ns'
    'compute image export to-object-uri' = '? h'
    'compute image get' = '? h'
    'compute image import from-object' = '? bn c h ns'
    'compute image import from-object-uri' = '? c h'
    'compute image list' = '? c h'
    'compute image update' = '? h'
    'compute instance action' = '? h'
    'compute instance attach-vnic' = '? h'
    'compute instance detach-vnic' = '? c h'
    'compute instance get' = '? h'
    'compute instance get-windows-initial-creds' = '? h'
    'compute instance launch' = '? c h'
    'compute instance list' = '? c h'
    'compute instance list-vnics' = '? h'
    'compute instance terminate' = '? h'
    'compute instance update' = '? h'
    'compute instance-console-connection create' = '? h'
    'compute instance-console-connection delete' = '? h'
    'compute instance-console-connection get' = '? h'
    'compute instance-console-connection get-plink-connection-string' = '? h'
    'compute instance-console-connection list' = '? c h'
    'compute shape list' = '? c h'
    'compute vnic-attachment get' = '? h'
    'compute vnic-attachment list' = '? c h'
    'compute volume-attachment attach' = '? h'
    'compute volume-attachment detach' = '? h'
    'compute volume-attachment get' = '? h'
    'compute volume-attachment list' = '? c h'
    'db backup create' = '? h'
    'db backup delete' = '? h'
    'db backup get' = '? h'
    'db backup list' = '? c h'
    'db data-guard-association create from-existing-db-system' = '? h'
    'db data-guard-association failover' = '? h'
    'db data-guard-association get' = '? h'
    'db data-guard-association list' = '? h'
    'db data-guard-association reinstate' = '? h'
    'db data-guard-association switchover' = '? h'
    'db database create' = '? h'
    'db database create-from-backup' = '? h'
    'db database delete' = '? h'
    'db database get' = '? h'
    'db database list' = '? c h'
    'db database patch' = '? h'
    'db database restore' = '? h'
    'db database update' = '? h'
    'db node get' = '? h'
    'db node list' = '? c h'
    'db node reset' = '? h'
    'db node soft-reset' = '? h'
    'db node start' = '? h'
    'db node stop' = '? h'
    'db patch get by-database' = '? h'
    'db patch get by-db-system' = '? h'
    'db patch list by-database' = '? h'
    'db patch list by-db-system' = '? h'
    'db patch-history get by-database' = '? h'
    'db patch-history get by-db-system' = '? h'
    'db patch-history list by-database' = '? h'
    'db patch-history list by-db-system' = '? h'
    'db system get' = '? h'
    'db system launch' = '? c h'
    'db system launch-from-backup' = '? c h'
    'db system list' = '? c h'
    'db system patch' = '? h'
    'db system terminate' = '? h'
    'db system update' = '? h'
    'db system-shape list' = '? c h'
    'db version list' = '? c h'
    'dns record domain delete' = '? c h'
    'dns record domain get' = '? c h'
    'dns record domain patch' = '? c h'
    'dns record domain update' = '? c h'
    'dns record rrset delete' = '? c h'
    'dns record rrset get' = '? c h'
    'dns record rrset patch' = '? c h'
    'dns record rrset update' = '? c h'
    'dns record zone get' = '? c h'
    'dns record zone patch' = '? c h'
    'dns record zone update' = '? c h'
    'dns zone create' = '? c h'
    'dns zone delete' = '? c h'
    'dns zone get' = '? c h'
    'dns zone list' = '? c h'
    'dns zone update' = '? c h'
    'email sender create' = '? c h'
    'email sender delete' = '? h'
    'email sender get' = '? h'
    'email sender list' = '? c h'
    'email suppression create' = '? c h'
    'email suppression delete' = '? h'
    'email suppression get' = '? h'
    'email suppression list' = '? c h'
    'fs export create' = '? h'
    'fs export delete' = '? h'
    'fs export get' = '? h'
    'fs export list' = '? c h'
    'fs export-set get' = '? h'
    'fs export-set list' = '? c h'
    'fs export-set update' = '? h'
    'fs file-system create' = '? c h'
    'fs file-system delete' = '? h'
    'fs file-system get' = '? h'
    'fs file-system list' = '? c h'
    'fs file-system update' = '? h'
    'fs mount-target create' = '? c h'
    'fs mount-target delete' = '? h'
    'fs mount-target get' = '? h'
    'fs mount-target list' = '? c h'
    'fs mount-target update' = '? h'
    'fs snapshot create' = '? h'
    'fs snapshot delete' = '? h'
    'fs snapshot get' = '? h'
    'fs snapshot list' = '? h'
    'iam auth-token create' = '? h'
    'iam auth-token delete' = '? h'
    'iam auth-token list' = '? h'
    'iam auth-token update' = '? h'
    'iam availability-domain list' = '? c h'
    'iam compartment create' = '? c h'
    'iam compartment get' = '? c h'
    'iam compartment list' = '? c h'
    'iam compartment update' = '? c h'
    'iam customer-secret-key create' = '? h'
    'iam customer-secret-key delete' = '? h'
    'iam customer-secret-key list' = '? h'
    'iam customer-secret-key update' = '? h'
    'iam dynamic-group create' = '? c h'
    'iam dynamic-group delete' = '? h'
    'iam dynamic-group get' = '? h'
    'iam dynamic-group list' = '? c h'
    'iam dynamic-group update' = '? h'
    'iam group add-user' = '? h'
    'iam group create' = '? c h'
    'iam group delete' = '? h'
    'iam group get' = '? h'
    'iam group list' = '? c h'
    'iam group list-users' = '? c h'
    'iam group remove-user' = '? c h'
    'iam group update' = '? h'
    'iam policy create' = '? c h'
    'iam policy delete' = '? h'
    'iam policy get' = '? h'
    'iam policy list' = '? c h'
    'iam policy update' = '? h'
    'iam region list' = '? h'
    'iam region-subscription create' = '? h'
    'iam region-subscription list' = '? h'
    'iam smtp-credential create' = '? h'
    'iam smtp-credential delete' = '? h'
    'iam smtp-credential list' = '? h'
    'iam smtp-credential update' = '? h'
    'iam tag create' = '? h'
    'iam tag get' = '? h'
    'iam tag list' = '? h'
    'iam tag reactivate' = '? h'
    'iam tag retire' = '? h'
    'iam tag update' = '? h'
    'iam tag-namespace create' = '? c h'
    'iam tag-namespace get' = '? h'
    'iam tag-namespace list' = '? c h'
    'iam tag-namespace reactivate' = '? h'
    'iam tag-namespace retire' = '? h'
    'iam tag-namespace update' = '? h'
    'iam user api-key delete' = '? h'
    'iam user api-key list' = '? h'
    'iam user api-key upload' = '? h'
    'iam user create' = '? c h'
    'iam user delete' = '? h'
    'iam user get' = '? h'
    'iam user list' = '? c h'
    'iam user list-groups' = '? c h'
    'iam user swift-password create' = '? h'
    'iam user swift-password delete' = '? h'
    'iam user swift-password list' = '? h'
    'iam user swift-password update' = '? h'
    'iam user ui-password create-or-reset' = '? h'
    'iam user update' = '? h'
    'iam user update-user-state' = '? h'
    'lb backend create' = '? h'
    'lb backend delete' = '? h'
    'lb backend get' = '? h'
    'lb backend list' = '? h'
    'lb backend update' = '? h'
    'lb backend-health get' = '? h'
    'lb backend-set create' = '? h'
    'lb backend-set delete' = '? h'
    'lb backend-set get' = '? h'
    'lb backend-set list' = '? h'
    'lb backend-set update' = '? h'
    'lb backend-set-health get' = '? h'
    'lb certificate create' = '? h'
    'lb certificate delete' = '? h'
    'lb certificate list' = '? h'
    'lb health-checker get' = '? h'
    'lb health-checker update' = '? h'
    'lb hostname create' = '? h'
    'lb hostname delete' = '? h'
    'lb hostname get' = '? h'
    'lb hostname list' = '? h'
    'lb hostname update' = '? h'
    'lb listener create' = '? h'
    'lb listener delete' = '? h'
    'lb listener update' = '? h'
    'lb load-balancer create' = '? c h'
    'lb load-balancer delete' = '? h'
    'lb load-balancer get' = '? h'
    'lb load-balancer list' = '? c h'
    'lb load-balancer-health get' = '? h'
    'lb load-balancer-health list' = '? c h'
    'lb path-route-set create' = '? h'
    'lb path-route-set delete' = '? h'
    'lb path-route-set get' = '? h'
    'lb path-route-set list' = '? h'
    'lb path-route-set update' = '? h'
    'lb policy list' = '? c h'
    'lb protocol list' = '? c h'
    'lb shape list' = '? c h'
    'lb work-request get' = '? h'
    'lb work-request list' = '? h'
    'network cpe create' = '? c h'
    'network cpe delete' = '? h'
    'network cpe get' = '? h'
    'network cpe list' = '? c h'
    'network cpe update' = '? h'
    'network cross-connect create' = '? c h'
    'network cross-connect delete' = '? h'
    'network cross-connect get' = '? h'
    'network cross-connect list' = '? c h'
    'network cross-connect update' = '? h'
    'network cross-connect-group create' = '? c h'
    'network cross-connect-group delete' = '? h'
    'network cross-connect-group get' = '? h'
    'network cross-connect-group list' = '? c h'
    'network cross-connect-group update' = '? h'
    'network cross-connect-location list' = '? c h'
    'network cross-connect-port-speed-shape list' = '? c h'
    'network cross-connect-status get' = '? h'
    'network dhcp-options create' = '? c h'
    'network dhcp-options delete' = '? h'
    'network dhcp-options get' = '? h'
    'network dhcp-options list' = '? c h'
    'network dhcp-options update' = '? h'
    'network drg create' = '? c h'
    'network drg delete' = '? h'
    'network drg get' = '? h'
    'network drg list' = '? c h'
    'network drg update' = '? h'
    'network drg-attachment create' = '? h'
    'network drg-attachment delete' = '? h'
    'network drg-attachment get' = '? h'
    'network drg-attachment list' = '? c h'
    'network drg-attachment update' = '? h'
    'network fast-connect-provider-service get' = '? h'
    'network fast-connect-provider-service list' = '? c h'
    'network fast-connect-provider-service virtual-circuit-bandwidth-shape list' = '? h'
    'network internet-gateway create' = '? c h'
    'network internet-gateway delete' = '? h'
    'network internet-gateway get' = '? h'
    'network internet-gateway list' = '? c h'
    'network internet-gateway update' = '? h'
    'network ip-sec-connection create' = '? c h'
    'network ip-sec-connection delete' = '? h'
    'network ip-sec-connection get' = '? h'
    'network ip-sec-connection get-config' = '? h'
    'network ip-sec-connection get-status' = '? h'
    'network ip-sec-connection list' = '? c h'
    'network ip-sec-connection update' = '? h'
    'network local-peering-gateway connect' = '? h'
    'network local-peering-gateway create' = '? c h'
    'network local-peering-gateway delete' = '? h'
    'network local-peering-gateway get' = '? h'
    'network local-peering-gateway list' = '? c h'
    'network local-peering-gateway update' = '? h'
    'network private-ip delete' = '? h'
    'network private-ip get' = '? h'
    'network private-ip list' = '? h'
    'network private-ip update' = '? h'
    'network public-ip create' = '? c h'
    'network public-ip delete' = '? h'
    'network public-ip get' = '? h'
    'network public-ip list' = '? c h'
    'network public-ip update' = '? h'
    'network remote-peering-connection connect' = '? h'
    'network remote-peering-connection create' = '? c h'
    'network remote-peering-connection delete' = '? h'
    'network remote-peering-connection get' = '? h'
    'network remote-peering-connection list' = '? c h'
    'network remote-peering-connection update' = '? h'
    'network route-table create' = '? c h'
    'network route-table delete' = '? h'
    'network route-table get' = '? h'
    'network route-table list' = '? c h'
    'network route-table update' = '? h'
    'network security-list create' = '? c h'
    'network security-list delete' = '? h'
    'network security-list get' = '? h'
    'network security-list list' = '? c h'
    'network security-list update' = '? h'
    'network subnet create' = '? c h'
    'network subnet delete' = '? h'
    'network subnet get' = '? h'
    'network subnet list' = '? c h'
    'network subnet update' = '? h'
    'network vcn create' = '? c h'
    'network vcn delete' = '? h'
    'network vcn get' = '? h'
    'network vcn list' = '? c h'
    'network vcn update' = '? h'
    'network virtual-circuit create' = '? c h'
    'network virtual-circuit delete' = '? h'
    'network virtual-circuit get' = '? h'
    'network virtual-circuit list' = '? c h'
    'network virtual-circuit update' = '? h'
    'network virtual-circuit-public-prefix bulk-add' = '? h'
    'network virtual-circuit-public-prefix bulk-delete' = '? h'
    'network virtual-circuit-public-prefix list' = '? h'
    'network vnic assign-private-ip' = '? h'
    'network vnic get' = '? h'
    'network vnic unassign-private-ip' = '? h'
    'network vnic update' = '? h'
    'os bucket create' = '? c h ns'
    'os bucket delete' = '? h ns'
    'os bucket get' = '? h ns'
    'os bucket list' = '? c h ns'
    'os bucket update' = '? c h ns'
    'os multipart abort' = '? bn h ns on'
    'os multipart list' = '? bn h ns'
    'os ns get' = '? h'
    'os ns get-metadata' = '? h ns'
    'os ns update-metadata' = '? h ns'
    'os object bulk-delete' = '? bn h ns'
    'os object bulk-download' = '? bn h ns'
    'os object bulk-upload' = '? bn h ns'
    'os object delete' = '? bn h ns'
    'os object get' = '? bn h ns'
    'os object head' = '? bn h ns'
    'os object list' = '? bn h ns'
    'os object put' = '? bn h ns'
    'os object rename' = '? bn h ns'
    'os object restore' = '? bn h ns'
    'os object restore-status' = '? bn h ns'
    'os object resume-put' = '? bn h ns'
    'os preauth-request create' = '? bn h ns on'
    'os preauth-request delete' = '? bn h ns'
    'os preauth-request get' = '? bn h ns'
    'os preauth-request list' = '? bn h ns'
    'setup autocomplete' = '? h'
    'setup config' = '? h'
    'setup keys' = '? h'
    'setup oci-cli-rc' = '? h'
    'setup repair-file-permissions' = '? h'
}
$script:ociCommandsWithShortParams = $ociCommandsToShortParams.Keys -join '|'

function OciTabExpansion($lastBlock) {
    $res = Oci-Invoke-Utf8ConsoleCommand { OciTabExpansionInternal $lastBlock }
	$res
}

function OciTabExpansionInternal($lastBlock) {
	$ociAliasPattern = GetOciAliasPattern 
	
	switch -regex ($lastBlock -replace "^$($ociAliasPattern) ","") {
		# Handles [oci|bmcs] <top-level command>
		"^(?<cmd>\w+?)$" {
            $com = $matches['cmd']
			$ociTopLevelCommands | Where-Object { $_ -like "$com*" }
		}
	
		# Handles [oci|bmcs] <top-level command> <sub-command> <sub-command> ...
        "^(?<cmd>$ociSubcommandKeys)\s+(?<op>\S*)$" {
            ociCmdOperations $ociSubcommands $matches['cmd'] $matches['op']
        }
		
		# Handles [oci|bmcs] <some level of commands> --<param>
        "^(?<cmd>$ociCommandsWithLongParams).* --(?<param>\S*)$" {
            expandOciLongParams $matches['cmd'] $matches['param']
        }

        # Handles [oci|bmcs] <some level of commands> -<shortparam>
        "^(?<cmd>$ociCommandsWithShortParams).* -(?<shortparam>\S*)$" {
            expandOciShortParams $matches['cmd'] $matches['shortparam']
        }
	}
}

function script:ociCmdOperations($commands, $command, $filter) {
    $commands.$command -split ' ' | Where-Object { $_ -like "$filter*" }
}

function script:expandOciLongParams($cmd, $filter) {
    $ociCommandsToLongParams[$cmd] -split ' ' |
        Where-Object { $_ -like "$filter*" } |
        Sort-Object |
        ForEach-Object { -join ("--", $_) }
}

function script:expandOciShortParams($cmd, $filter) {
    $ociCommandsToShortParams[$cmd] -split ' ' |
        Where-Object { $_ -like "$filter*" } |
        Sort-Object |
        ForEach-Object { -join ("-", $_) }
}

function GetOciAliasPattern() {
	$ociAliases = @("oci", "bmcs") + @(Get-Alias | where { $_.Definition -eq "oci" } | select -Exp Name) + @(Get-Alias | where { $_.Definition -eq "bmcs" } | select -Exp Name)
	$ociAliasPattern = "($($ociAliases -join '|'))"
	
	return $ociAliasPattern
}

function Oci-Invoke-Utf8ConsoleCommand([ScriptBlock]$cmd) {
    $currentEncoding = [Console]::OutputEncoding
    $errorCount = $global:Error.Count
    try {
        # A native executable that writes to stderr AND has its stderr redirected will generate non-terminating
        # error records if the user has set $ErrorActionPreference to Stop. Override that value in this scope.
        $ErrorActionPreference = 'Continue'
        if ($currentEncoding.IsSingleByte) {
            [Console]::OutputEncoding = [Text.Encoding]::UTF8
        }
        & $cmd
    }
    finally {
        if ($currentEncoding.IsSingleByte) {
            [Console]::OutputEncoding = $currentEncoding
        }

        # Clear out stderr output that was added to the $Error collection, putting those errors in a module variable
        if ($global:Error.Count -gt $errorCount) {
            $numNewErrors = $global:Error.Count - $errorCount
            $invokeErrors.InsertRange(0, $global:Error.GetRange(0, $numNewErrors))
            if ($invokeErrors.Count -gt 256) {
                $invokeErrors.RemoveRange(256, ($invokeErrors.Count - 256))
            }
            $global:Error.RemoveRange(0, $numNewErrors)
        }
    }
}

if (Test-Path Function:\TabExpansion) {
    Rename-Item Function:\TabExpansion TabExpansionBackupFromOciAutocomplete
}

function TabExpansion($line, $lastWord) {
    $lastBlock = [regex]::Split($line, '[|;]')[-1].TrimStart()

	$ociAliasPattern = GetOciAliasPattern
	
	switch -regex ($lastBlock) {
        # Execute OCI/BMCS tab completion
        "^$($ociAliasPattern) (.*)" { OciTabExpansion $lastBlock }

        # Fall back on existing tab expansion
        default {
            if (Test-Path Function:\TabExpansionBackupFromOciAutocomplete) {
                TabExpansionBackupFromOciAutocomplete $line $lastWord
            }
        }
    }
}